#ifndef PROCESS_H
#define PROCESS_H

#include <Include/PlatformDefinitions.hpp>


#include <util/PlatformUtils.hpp>
#include <sax/SAXException.hpp>



#include <XalanDOM/XalanDOMException.hpp>



#include <PlatformSupport/DOMStringHelper.hpp>
#include <PlatformSupport/DOMStringPrintWriter.hpp>
#include <PlatformSupport/XalanOutputStreamPrintWriter.hpp>
#include <PlatformSupport/XalanFileOutputStream.hpp>
#include <PlatformSupport/XalanStdOutputStream.hpp>



#include <Include/XalanAutoPtr.hpp>



#include <DOMSupport/DOMSupportDefault.hpp>



#include <XPath/XObjectFactoryDefault.hpp>
#include <XPath/XPathEnvSupportDefault.hpp>
#include <XPath/XPath.hpp>
#include <XPath/XPathExecutionContextDefault.hpp>
#include <XPath/XPathFactoryDefault.hpp>
#include <XPath/XPathProcessorImpl.hpp>



#include <XercesParserLiaison/XercesParserLiaison.hpp>
#include <XercesParserLiaison/XercesDOMSupport.hpp>



#include <XMLSupport/FormatterToDOM.hpp>
#include <XMLSupport/FormatterToHTML.hpp>
#include <XMLSupport/FormatterToNull.hpp>
#include <XMLSupport/FormatterToText.hpp>
#include <XMLSupport/FormatterToXML.hpp>
#include <XMLSupport/FormatterTreeWalker.hpp>



#include <XalanSourceTree/FormatterToSourceTree.hpp>
#include <XalanSourceTree/XalanSourceTreeDOMSupport.hpp>
#include <XalanSourceTree/XalanSourceTreeDocument.hpp>
#include <XalanSourceTree/XalanSourceTreeInit.hpp>
#include <XalanSourceTree/XalanSourceTreeParserLiaison.hpp>


typedef map<CharVectorType, CharVectorType, less<CharVectorType> > String2StringMapType;

struct CmdLineParams
{
	String2StringMapType paramsMap;
	bool doStackDumpOnError;
	bool escapeCData;
	bool setQuietConflictWarnings;
	bool setQuietMode;
	bool shouldExpandEntityRefs;
	bool stripCData;
	bool versionOnly;
	bool traceTemplates;
	bool traceGenerationEvent;
	bool traceSelectionEvent;
	bool traceTemplateChildren;
	bool shouldWriteXMLHeader;
	bool doValidation;
	bool noIndent;
	bool formatToNull;
	bool formatToSourceTree;
	bool useDOM;
	bool useDOMForRTFs;
	int indentAmount;
	int outputType;
	CharVectorType outFileName;
	CharVectorType specialCharacters;
	CharVectorType xslFileName;
	CharVectorType inFileName;

	vector<char *> ScommandArgs;
        CharVectorType SInitFile;

	CmdLineParams() :
		paramsMap(),
		doStackDumpOnError(false),
		escapeCData(false),
		setQuietConflictWarnings(false),
		setQuietMode(false),
		shouldExpandEntityRefs(false),
		stripCData(false),
		versionOnly(false),
		traceTemplates(false),
		traceGenerationEvent(false),
		traceSelectionEvent(false),
		traceTemplateChildren(false),
		shouldWriteXMLHeader(true),
		doValidation(false),
		noIndent(false),
		formatToNull(false),
		formatToSourceTree(false),
		useDOM(false),
		useDOMForRTFs(false),
		indentAmount(-1),
		outputType(-1),
		outFileName(),
		specialCharacters(),
		xslFileName(),
		inFileName()
	{
	}
};

extern CmdLineParams *CommandLineParameters;

bool isTerminatorFlag(const char *arg);

#endif
